/**
 * generated by Xtext 2.19.0
 */
package fr.istic.mML.impl;

import fr.istic.mML.MMLPackage;
import fr.istic.mML.SimpleSplit;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Simple Split</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link fr.istic.mML.impl.SimpleSplitImpl#getValidationPercent <em>Validation Percent</em>}</li>
 * </ul>
 *
 * @generated
 */
public class SimpleSplitImpl extends StrategyEvaluationImpl implements SimpleSplit
{
  /**
   * The default value of the '{@link #getValidationPercent() <em>Validation Percent</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getValidationPercent()
   * @generated
   * @ordered
   */
  protected static final int VALIDATION_PERCENT_EDEFAULT = 0;

  /**
   * The cached value of the '{@link #getValidationPercent() <em>Validation Percent</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getValidationPercent()
   * @generated
   * @ordered
   */
  protected int validationPercent = VALIDATION_PERCENT_EDEFAULT;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected SimpleSplitImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return MMLPackage.Literals.SIMPLE_SPLIT;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public int getValidationPercent()
  {
    return validationPercent;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void setValidationPercent(int newValidationPercent)
  {
    int oldValidationPercent = validationPercent;
    validationPercent = newValidationPercent;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, MMLPackage.SIMPLE_SPLIT__VALIDATION_PERCENT, oldValidationPercent, validationPercent));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case MMLPackage.SIMPLE_SPLIT__VALIDATION_PERCENT:
        return getValidationPercent();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case MMLPackage.SIMPLE_SPLIT__VALIDATION_PERCENT:
        setValidationPercent((Integer)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case MMLPackage.SIMPLE_SPLIT__VALIDATION_PERCENT:
        setValidationPercent(VALIDATION_PERCENT_EDEFAULT);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case MMLPackage.SIMPLE_SPLIT__VALIDATION_PERCENT:
        return validationPercent != VALIDATION_PERCENT_EDEFAULT;
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuilder result = new StringBuilder(super.toString());
    result.append(" (validationPercent: ");
    result.append(validationPercent);
    result.append(')');
    return result.toString();
  }

} //SimpleSplitImpl
